Codeforces Round #309 (Div. 1) D. Nudist Beach 二分 贪心

32 篇文章 0 订阅
11 篇文章 0 订阅
D. Nudist Beach
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Nudist Beach is planning a military operation to attack the Life Fibers. In this operation, they will attack and capture several cities which are currently under the control of the Life Fibers.

There are n cities, labeled from 1 to n, and m bidirectional roads between them. Currently, there are Life Fibers in every city. In addition, there are k cities that are fortresses of the Life Fibers that cannot be captured under any circumstances. So, the Nudist Beach can capture an arbitrary non-empty subset of cities with no fortresses.

After the operation, Nudist Beach will have to defend the captured cities from counterattack. If they capture a city and it is connected to many Life Fiber controlled cities, it will be easily defeated. So, Nudist Beach would like to capture a set of cities such that for each captured city the ratio of Nudist Beach controlled neighbors among all neighbors of that city is as high as possible.

More formally, they would like to capture a non-empty set of cities S with no fortresses of Life Fibers. The strength of a city  is defined as (number of neighbors of x in S) / (total number of neighbors of x). Here, two cities are called neighbors if they are connnected with a road. The goal is to maximize the strength of the weakest city in S.

Given a description of the graph, and the cities with fortresses, find a non-empty subset that maximizes the strength of the weakest city.

Input

The first line of input contains three integers n, m, k (2  ≤  n  ≤ 100 0001 ≤ m ≤ 100 0001 ≤ k ≤ n - 1).

The second line of input contains k integers, representing the cities with fortresses. These cities will all be distinct.

The next m lines contain the roads. The i-th of these lines will have 2 integers ai, bi (1 ≤ ai, bi ≤ nai ≠ bi). Every city will have at least one road adjacent to it.

There is no more than one road between each pair of the cities.

Output

The first line should contain an integer r, denoting the size of an optimum set (1 ≤ r ≤ n - k).

The second line should contain r integers, denoting the cities in the set. Cities may follow in an arbitrary order. This line should not contain any of the cities with fortresses.

If there are multiple possible answers, print any of them.

Sample test(s)
input
9 8 4
3 9 6 8
1 2
1 3
1 4
1 5
2 6
2 7
2 8
2 9
output
3
1 4 5
input
10 8 2
2 9
1 3
2 9
4 5
5 6
6 7
7 8
8 10
10 4
output
8
1 5 4 8 10 6 3 7
Note

The first example case achieves a strength of 1/2. No other subset is strictly better.

The second example case achieves a strength of 1. Note that the subset doesn't necessarily have to be connected.

题意是,给定一个图,要求选中一个子集,使总子集所有的点的权值最小值最大。定义一个点的权值为(该点的边中,属于选择子集的内部边)/该点的所有边。

第一种方法:二分的方法,枚举一个最小权值,判定,能否找出一个合适的子集。

怎样找一个子集呢,先把所有的点加入目标集,如果,目标集中有点不能满点最小权值,则删除这个点,再把与这个点所有相连的点更新权值并加入到队列中。这个过程有点用bfs实现,有点像spfa过程。所以总的复杂度达到 o(log(10^7)  * k * (n + m));总的复杂度可以ac,但复杂度太高了。可以肯定是正确的。

#define N 100050
#define M 100005
#define maxn 205
#define MOD 1000000000000000007
int n,m,k,vis[N],in[N],t,a,b,sum[N],sumv[N];
double fn[N];
vector<int> p[N];
queue<int> q;
set<int> myset,ans;
set<int>::iterator it;
bool cmp(double a ,double mid){
    return a  - mid > -EPS;
}
bool isRight(double mid){
    while( !q.empty() ) q.pop();
    myset.clear();
    memset(fn,0,sizeof(fn));
    FI(n){
        if(vis[i]!=0){
            fn[i] += ((double) sum[i] / (double) sumv[i]) ;
            if(cmp(fn[i],mid)){
                myset.insert(i);
                q.push(i);
            }
            else {
                FJ(p[i].size()){
                    int t = p[i][j];
                    fn[t] -= 1.0 / (double)sumv[t];
                }
            }
        }
        in[i] = true;
    }
    while(!myset.empty() && !q.empty()){
        int top = q.front();q.pop();
        in[top] = false;
        if(!cmp(fn[top],mid)){
            myset.erase(top);
            FI(p[top].size()){
                int t = p[top][i];
                fn[t] -= 1.0 / (double)sumv[t];
                if(!in[t] && myset.count(t)){
                    q.push(t);
                    in[t] = true;
                }
            }
        }
    }
    return !myset.empty();
}
int main()
{
    while(S2(n,m)!=EOF)
    {
        S(k);
        FI(n) p[i].clear();
        memset(vis,-1,sizeof(vis));
        memset(sum,0,sizeof(sum));
        memset(sumv,0,sizeof(sumv));
        FI(k) {
            S(t);
            t--;
            vis[t] = 0;
        }
        FI(m){
            S2(a,b);
            a--,b--;
            if(vis[b]) {
                p[a].push_back(b);sum[a]++;
            }
            sumv[a]++;
            if(vis[a]){
                p[b].push_back(a);sum[b]++;
            }
            sumv[b]++;
        }
        double s = -1.0,e = 1.0,mid;
        while(e - s > EPS){
            mid = (s + e) /2;
            if(isRight(mid)){
                ans.clear();
                ans.insert(myset.begin(),myset.end());
                s = mid;
            }
            else
                e = mid;
        }
        printf("%d\n",ans.size());
        for(it = ans.begin();it != ans.end();it ++){
            printf("%d ",*it + 1);
        }
        cout<<endl;
    }
    return 0;
}
第二种方法,贪心的方法。

用类似于Disjtra的最短路用优先队列的,贪心的方法每次去掉 权值最小的点,因为,去掉了权值小的点,就有可以使的总的最小权值增大,这种贪心策略是有效的,实现上,就和求最短路的方法有点类似,不过这里,如果在队列中要更新,不在队列中不更新(因为不在队列中对结果没有影响,自然不用更新,在队列中,对结果有影响,所以要更新)。总的复杂度为n * log(n),比第一种方式,应该是快了10倍以上,也就是说快了二分枚举那里。


struct node{
    double v;
    int s;int sum;
    node(int ss,double vv,int tsum){
        s = ss;v = vv;sum = tsum;
    }
    bool operator < (const node a) const{
        return v > a.v;
    }
};
int n,m,k,vis[N],in[N],t,a,b,sum[N],sumv[N],ina[N];
double fn[N],ansd;
vector<int> p[N],ans;
priority_queue<node> q;
bool cmp(double a ,double mid){
    return a  - mid > -EPS;
}
bool solve(){
    while( !q.empty() ) q.pop();
    FI(n){
        if(vis[i]!=0){
            fn[i] = ((double) sum[i] / (double) sumv[i]) ;
            q.push(node(i,fn[i],sum[i]));in[i] = true;
        }
        else in[i] = false;
    }
    ansd = -1;
    while(!q.empty()){
        node top = q.top();q.pop();
        if(top.sum != sum[top.s]) {
            continue;
        }
        if(top.v > ansd){
            ansd = top.v;
            FI(n) ina[i] = in[i];
        }
        in[top.s] = false;
        FI(p[top.s].size()){
            int t = p[top.s][i];
            if(in[t])
            {
                sum[t]--;
                fn[t] = (double)sum[t] / (double)sumv[t];
                q.push(node(t,fn[t],sum[t]));
            }
        }
    }
    return true;
}
int main()
{
    while(S2(n,m)!=EOF)
    {
        S(k);
        FI(n) p[i].clear();
        memset(vis,-1,sizeof(vis));
        memset(sum,0,sizeof(sum));
        memset(sumv,0,sizeof(sumv));
        FI(k) {
            S(t);
            t--;
            vis[t] = 0;
        }
        FI(m){
            S2(a,b);
            a--,b--;
            if(vis[b]) {
                p[a].push_back(b);sum[a]++;
            }
            sumv[a]++;
            if(vis[a]){
                p[b].push_back(a);sum[b]++;
            }
            sumv[b]++;
        }
        solve();
        ans.clear();
        FI(n){
            if(ina[i]){
                ans.push_back(i);
            }
        }
        printf("%d\n",ans.size());
        FI(ans.size()){
            printf("%d ",ans[i] + 1);
        }
        cout<<endl;
    }
    return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值